"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactContextHooksStore = require("react-context-hooks-store");

var _core = require("@blueprintjs/core");

var _reactDndHtml5Backend = _interopRequireDefault(require("react-dnd-html5-backend"));

var _reactDnd = require("react-dnd");

var _BpTable = _interopRequireDefault(require("../BpTable"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var dragDirection = function dragDirection(dragIndex, hoverIndex, initialClientOffset, clientOffset, sourceClientOffset) {
  var hoverMiddleY = (initialClientOffset.y - sourceClientOffset.y) / 2;
  var hoverClientY = clientOffset.y - sourceClientOffset.y;

  if (dragIndex < hoverIndex && hoverClientY > hoverMiddleY) {
    return 'downward';
  }

  if (dragIndex > hoverIndex && hoverClientY < hoverMiddleY) {
    return 'upward';
  }
};

var BodyRow = function BodyRow(props) {
  var isOver = props.isOver,
      connectDragSource = props.connectDragSource,
      connectDropTarget = props.connectDropTarget,
      moveRow = props.moveRow,
      dragRow = props.dragRow,
      clientOffset = props.clientOffset,
      sourceClientOffset = props.sourceClientOffset,
      initialClientOffset = props.initialClientOffset,
      restProps = _objectWithoutProperties(props, ["isOver", "connectDragSource", "connectDropTarget", "moveRow", "dragRow", "clientOffset", "sourceClientOffset", "initialClientOffset"]);

  var style = _objectSpread({}, restProps.style, {
    cursor: 'move'
  });

  var className = restProps.className;

  if (isOver && initialClientOffset) {
    var direction = dragDirection(dragRow.index, restProps.index, initialClientOffset, clientOffset, sourceClientOffset);

    if (direction === 'downward') {
      className += ' app-drop-over-downward';
    }

    if (direction === 'upward') {
      className += ' app-drop-over-upward';
    }
  }

  return connectDragSource(connectDropTarget(_react["default"].createElement("tr", _extends({}, restProps, {
    className: className,
    style: style
  }))));
};

var rowSource = {
  beginDrag: function beginDrag(props) {
    return {
      index: props.index
    };
  }
};
var rowTarget = {
  drop: function drop(props, monitor) {
    var dragIndex = monitor.getItem().index;
    var hoverIndex = props.index;

    if (dragIndex === hoverIndex) {
      return;
    }

    props.moveRow(dragIndex, hoverIndex);
    monitor.getItem().index = hoverIndex;
  }
};
BodyRow = (0, _reactDnd.DropTarget)('row', rowTarget, function (connect, monitor) {
  return {
    connectDropTarget: connect.dropTarget(),
    isOver: monitor.isOver(),
    sourceClientOffset: monitor.getSourceClientOffset()
  };
})((0, _reactDnd.DragSource)('row', rowSource, function (connect, monitor) {
  return {
    connectDragSource: connect.dragSource(),
    dragRow: monitor.getItem(),
    clientOffset: monitor.getClientOffset(),
    initialClientOffset: monitor.getInitialClientOffset()
  };
})(BodyRow));

function List(props) {
  var _props$fieldList = props.fieldList,
      fieldList = _props$fieldList === void 0 ? [] : _props$fieldList,
      _props$dataList = props.dataList,
      dataList = _props$dataList === void 0 ? [] : _props$dataList,
      isDrag = props.isDrag,
      dragName = props.dragName,
      isLoading = props.isLoading,
      tableProps = _objectWithoutProperties(props, ["fieldList", "dataList", "isDrag", "dragName", "isLoading"]);

  (0, _react.useEffect)(function () {//event
  }, [fieldList, dataList]);

  var moveRow = function moveRow(dragIndex, hoverIndex) {
    var dragRow = dataList[dragIndex];
    var hoverRow = dataList[hoverIndex];

    function updateRank() {//update
    }
  };

  if (isDrag) {
    tableProps.onRow = function (record, index) {
      return {
        index: index,
        moveRow: moveRow
      };
    };

    tableProps.components = {
      body: {
        row: BodyRow
      }
    };
  } // tableProps.onRow = props.onRow;
  // const isLoading = true;


  return _react["default"].createElement(_react["default"].Fragment, null, isLoading && _react["default"].createElement(_core.Spinner, {
    intent: 'primary',
    size: 30
  }), !isLoading && _react["default"].createElement(_reactDnd.DndProvider, {
    backend: _reactDndHtml5Backend["default"]
  }, _react["default"].createElement(_BpTable["default"], _extends({
    bordered: true,
    columns: fieldList,
    data: dataList,
    emptyText: _react["default"].createElement(_core.NonIdealState, {
      icon: "th",
      title: "Ch\u01B0a c\xF3 d\u1EEF li\u1EC7u"
    })
  }, tableProps))));
} // const memoProps = (prevProps, nextProps) => {
//   if (JSON.stringify(prevProps.fieldList) !== JSON.stringify(nextProps.fieldList)) {
//     return false;
//   }
//
//   if (JSON.stringify(prevProps.dataList) !== JSON.stringify(nextProps.dataList)) {
//     return false;
//   }
//
//   if (prevProps.isLoading !== nextProps.isLoading) {
//     return false;
//   }
//
//   return true;
// };


var _default = (0, _reactContextHooksStore.memoize)(List);

exports["default"] = _default;