import React from 'react';
import RcTable from 'rc-table';
import classNames from 'classnames';
import { memoize } from 'react-context-hooks-store';

import './index.less';

const prefixCls = 'bp3-table';

function Table(props) {
  const { className, bordered, size = 'default', pagination, ...restProps } = props;

  return (
    <div className={classNames(`${prefixCls}-wrapper`, className)}>
      <RcTable
        // tableLayout="auto"
        className={classNames({
          [`${prefixCls}-${size}`]: size,
          [`${prefixCls}-bordered`]: bordered,
        })}
        rowKey={(record) => record._id || record.id}
        prefixCls={prefixCls}
        {...restProps}
      />
    </div>
  )
}

export default memoize(Table);
